package compat
if (word(2 $loadinfo()) != [pf]) {
	load -pf $word(1 $loadinfo());
	return;
};
# The following functions were all pulled from the 'builtins' script
# written by David B. Kratter and distributed with EPIC5.
# Thanks BlackJac!
stub alias pfsave -pf save;

alias lastserver (void) {
        return $serverctl(last_server);
};

alias igmask (pattern, void) {
        return $ignorectl(pattern $pattern);
};

alias igtype (pattern, void) {
        return $strip(/+^ $ignorectl(get $ignorectl(refnum $pattern) levels));
};

alias rigmask (pattern, void) {
        return $ignorectl(rpattern $pattern);
};

alias rigtype (...) {
        return $ignorectl(with_type $*);
};

alias servergroup (refnum default "$serverctl(from_server)", void) {
	if (:group = serverctl(get $refnum group)) {
		return $group;
	};
	return <default>;
};

alias servername (refnum default "$serverctl(from_server)", void) {
	if (:name = serverctl(get $refnum itsname)) {
		return $name;
	};
	return <none>;
};

alias servernick (refnum default "$serverctl(from_server)", void) {
	return $serverctl(get $refnum nickname);
};

alias servernum (refnum default "$serverctl(from_server)", void) {
	if ((:num = serverctl(refnum $refnum)) >= -1) {
		return $num;
	};
	return -1;
};

alias serverourname (refnum default "$serverctl(from_server)", void) {
	if (:ourname = serverctl(get $refnum name)) {
		return $ourname;
	};
	return <none>;
};

alias servertype (refnum default "$serverctl(from_server)", void) {
	return $serverctl(get $refnum protocol);
};

alias winbound (winnum default 0, void) {
	return;
};

alias wincursorline (winnum default 0, void) {
	if ((:cursorline = windowctl(get $windowctl(refnum $winnum) cursor)) >= -1) {
		return $cursorline;
	};
	return -1;
};

alias winlevel (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) window_level);
};

alias winline (linenum, winnum default 0, void) {
	if ((:line = windowctl(get $windowctl(get refnum $winnum) line $linenum)) >= -1) {
		return $line;
	};
	return -1;
};

alias winnam (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) name);
};

alias winnicklist (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) nicklist);
};

alias winnum (winnum default 0, void) {
	if (:num = windowctl(get $windowctl(refnum $winnum) refnum)) {
		return $num;
	};
	return -1;
};

alias winquery (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) query);
};

alias winrefs (void) {
	return $windowctl(refnums);
};

alias winscreen (winnum default 0, void) {
	if ((:screen = windowctl(get $windowctl(refnum $winnum) screen)) >= -1) {
		return $screen;
	};
	return -1;
};

alias winscrollbacksize (winnum default 0, void) {
	if ((:scrollbacksize = windowctl(get $windowctl(refnum $winnum) display_buffer_size)) >= -1) {
		return $scrollbacksize;
	};
	return -1;
};

alias winserv (winnum default 0, void) {
	if ((:serv = windowctl(get $windowctl(refnum $winnum) server)) >= -2) {
		return $serv;
	};
	return -1;
};

alias winsize (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) display_size);
};

alias winstatsize (winnum default 0, void) {
	if ((:statsize = windowctl(get $windowctl(refnum $winnum) double)) > -1) {
		return ${statsize + 1};
	};
	return -1;
};

alias winvisible (winnum default 0, void) {
	if ((:visible = windowctl(get $windowctl(refnum $winnum) visible)) >= -1) {
		return $visible;
	};
	return -1;
};

# HOOKS #

#^on ^send_public "*" {
#	echo ${!iscurchan($0) ? [$0] : []}> $1-;
#};

# FULL_STATUS_LINE

oldset full_status_line bool {
	if ([$0] == [on]) {
		^set status_format $before(-1  $status_format);
		^set status_format1 $before(-1  $status_format1);
		^set status_format2 $before(-1  $status_format2);
	} else {
		^set status_format $status_format;
		^set status_format1 $status_format1;
		^set status_format2 $status_format2;
	};
};

set full_status_line on;

# REVERSE_STATUS_LINE

oldset reverse_status_line bool {
	if ([$0] == [on]) {
		^set status_format $after(1  $status_format);
		^set status_format1 $after(1  $status_format1);
		^set status_format2 $after(1  $status_format2);
	} else {
		^set status_format $status_format;
		^set status_format1 $status_format1;
		^set status_format2 $status_format2;
	};
};

set reverse_status_line on;

#misc aliases/to go with functs that common people use.
#whowas...
alias whowas (nick, number default "$num_of_whowas", void) {
        //whowas $nick $number;
};
oldset auto_whowas bool {
        if ([$0] == [on]) {
                ^on #-401 1 "*" {
                        whowas $1;
                };
        } else {
                ^on #-401 1 -"*";
        };
};

#auto_rejoin stuff...
^on #-kick 1 '$$servernick() *' {
        if (getset(auto_rejoin) == [on]) {
                if (:delay = getset(auto_rejoin_delay)) {
                        timer -w $winnum() $delay join $2;
                } else {
                        defer join $2;
                };
        };
};
